VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "SML2 MapEditor - {FILE}"
   ClientHeight    =   4440
   ClientLeft      =   45
   ClientTop       =   390
   ClientWidth     =   6600
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "main.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   296
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   440
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdAbout 
      Caption         =   "About"
      Height          =   315
      Left            =   5640
      TabIndex        =   8
      Top             =   4020
      Width           =   855
   End
   Begin VB.CommandButton cmdHelp 
      Caption         =   "Help"
      Height          =   315
      Left            =   4800
      TabIndex        =   9
      Top             =   4020
      Width           =   855
   End
   Begin VB.CommandButton cmdLoadAnotherROM 
      Caption         =   "Load another ROM"
      Height          =   315
      Left            =   4800
      TabIndex        =   10
      Top             =   3720
      Width           =   1695
   End
   Begin VB.CommandButton cmdSaveMap 
      Caption         =   "Save Map"
      Height          =   315
      Left            =   5400
      TabIndex        =   6
      Top             =   3120
      Width           =   975
   End
   Begin VB.CommandButton cmdLoadMap 
      Caption         =   "Load Map"
      Height          =   315
      Left            =   4440
      TabIndex        =   7
      Top             =   3120
      Width           =   975
   End
   Begin VB.Frame fraChooseMap 
      Caption         =   "Choose Map"
      Height          =   1020
      Left            =   4320
      TabIndex        =   4
      Top             =   2520
      Width           =   2175
      Begin VB.ComboBox cboMap 
         Height          =   315
         Left            =   120
         Style           =   2  'Dropdown List
         TabIndex        =   5
         Top             =   240
         Width           =   1935
      End
   End
   Begin VB.Frame fraTileset 
      Caption         =   "Tileset"
      Height          =   2295
      Left            =   4320
      TabIndex        =   2
      Top             =   120
      Width           =   2175
      Begin VB.PictureBox pbxTileset 
         BorderStyle     =   0  'None
         Height          =   1920
         Left            =   120
         ScaleHeight     =   128
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   128
         TabIndex        =   3
         Top             =   240
         Width           =   1920
      End
   End
   Begin VB.Frame fraMap 
      Caption         =   "Map"
      Height          =   4215
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4095
      Begin VB.PictureBox pbxMap 
         BorderStyle     =   0  'None
         Height          =   3840
         Left            =   120
         ScaleHeight     =   256
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   256
         TabIndex        =   1
         Top             =   240
         Width           =   3840
      End
   End
   Begin VB.Label lblSelection 
      Caption         =   "Selection: None"
      Height          =   255
      Left            =   4320
      TabIndex        =   11
      Top             =   3660
      Visible         =   0   'False
      Width           =   2175
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdAbout_Click()
  frmAbout.Show vbModal
End Sub

Private Sub cmdHelp_Click()
  frmHelp.Show vbModal
End Sub

Private Sub cmdLoadAnotherROM_Click()
  PickROM
End Sub

Private Sub cmdLoadMap_Click()
  LoadMap cboMap.ListIndex
End Sub

Private Sub cmdSaveMap_Click()
  SaveMap
End Sub

Private Sub Form_Unload(Cancel As Integer)
  If Not CheckSave Then Cancel = 1 Else End
End Sub

Private Sub pbxMap_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
  pbxMap_MouseMove Button, Shift, X, Y
End Sub

Private Sub pbxMap_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  Dim TileX As Long, TileY As Long, CurX As Integer, CurY As Integer
  
  If Not (Button = vbLeftButton Or Button = vbRightButton) Then Exit Sub
  If X < 0 Or X > 255 Or Y < 0 Or Y > pbxMap.ScaleHeight - 1 Then Exit Sub
  TileX = X \ 8
  TileY = Y \ 8
  If Button = vbLeftButton And Not NoSelection Then
    If StdSelect Then
      PlaceTile TileX, TileY, TileSelectedX, TileSelectedY
    ElseIf Not StdSelect And Not MapSelecting And Not MapSelected Then
      For CurX = 0 To SelectWidth
        For CurY = 0 To SelectHeight
          PlaceTile TileX + CurX, TileY + CurY, SelStartX + CurX, SelStartY + CurY
        Next CurY
      Next CurX
    ElseIf MapSelected Then
      For CurX = 0 To MapSelectWidth
        For CurY = 0 To MapSelectHeight
          PlaceTile TileX + CurX, TileY + CurY, MapSelectTiles(CurX, CurY, 0), MapSelectTiles(CurX, CurY, 1)
        Next CurY
      Next CurX
    End If
    pbxMap_Paint
    Dirty = True
    If fraMap.Caption <> "Map (modified)" Then fraMap.Caption = "Map (modified)"
  ElseIf Button = vbRightButton Then
    If MapSelecting Then
      If TileX >= MapSelStartX Then MapSelectWidth = TileX - MapSelStartX
      If TileY >= MapSelStartY Then MapSelectHeight = TileY - MapSelStartY
    Else
      StdSelect = False
      Selecting = False
      NoSelection = False
      MapSelected = False
      MapSelecting = True
      MapSelectWidth = 0
      MapSelectHeight = 0
      MapSelStartX = TileX
      MapSelStartY = TileY
    End If
    pbxTileset_Paint
    pbxMap_Paint
  End If
End Sub

Private Sub pbxMap_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
  Dim CurX As Integer, CurY As Integer
  
  If Button = vbRightButton And MapSelecting Then
    MapSelecting = False
    MapSelected = True
    StdSelect = False
    ReDim MapSelectTiles(MapSelectWidth, MapSelectHeight, 1)
    For CurX = 0 To MapSelectWidth
      For CurY = 0 To MapSelectHeight
        MapSelectTiles(CurX, CurY, 0) = MapArray(MapSelStartX + CurX, MapSelStartY + CurY, 0)
        MapSelectTiles(CurX, CurY, 1) = MapArray(MapSelStartX + CurX, MapSelStartY + CurY, 1)
      Next CurY
    Next CurX
    lblSelection.Caption = "Selection:" + Str(MapSelectWidth) + "x" + Trim(Str(MapSelectHeight)) + " tiles"
  End If
End Sub

Private Sub pbxMap_Paint()
  MapBuffer.PaintPicture pbxMap.hdc
  If MapSelecting And Not NoSelection Then
    pbxMap.Line ((MapSelStartX * 8) - 2, (MapSelStartY * 8) - 2)-(((MapSelStartX + MapSelectWidth) * 8) + 9, ((MapSelStartY + MapSelectHeight) * 8) + 9), RGB(255, 0, 0), B
    pbxMap.Line ((MapSelStartX * 8) - 1, (MapSelStartY * 8) - 1)-(((MapSelStartX + MapSelectWidth) * 8) + 8, ((MapSelStartY + MapSelectHeight) * 8) + 8), RGB(255, 0, 0), B
  End If
End Sub

Private Sub pbxTileset_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
  pbxTileset_MouseMove Button, Shift, X, Y
End Sub

Private Sub pbxTileset_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  Dim dX As Integer, dy As Integer
  
  If X < 0 Or X > 127 Or Y < 0 Or Y > 127 Then Exit Sub
  dX = X \ 8
  dy = Y \ 8
  If Button = vbLeftButton Then
    StdSelect = True
    MapSelecting = False
    MapSelected = False
    Selecting = False
    NoSelection = False
    TileSelectedX = dX
    TileSelectedY = dy
    pbxTileset_Paint
    pbxMap_Paint
  ElseIf Button = vbRightButton Then
    StdSelect = False
    If Selecting Then
      If dX >= SelStartX Then SelectWidth = dX - SelStartX
      If dy >= SelStartY Then SelectHeight = dy - SelStartY
    Else
      MapSelecting = False
      MapSelected = False
      Selecting = True
      NoSelection = False
      SelectWidth = 0
      SelectHeight = 0
      SelStartX = dX
      SelStartY = dy
    End If
    pbxTileset_Paint
    pbxMap_Paint
  End If
End Sub

Private Sub pbxTileset_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
  Selecting = False
  If StdSelect Then
    lblSelection.Caption = "Selection: one tile"
  Else
    lblSelection.Caption = "Selection:" + Str(SelectWidth) + "x" + Trim(Str(SelectHeight)) + " tiles"
  End If
End Sub

Private Sub pbxTileset_Paint()
  TilesetBuffer.PaintPicture pbxTileset.hdc
  If Not MapSelected And Not MapSelecting And Not NoSelection Then
    If StdSelect Then
      pbxTileset.Line ((TileSelectedX * 8) - 2, (TileSelectedY * 8) - 2)-((TileSelectedX * 8) + 9, (TileSelectedY * 8) + 9), RGB(255, 0, 0), B
      pbxTileset.Line ((TileSelectedX * 8) - 1, (TileSelectedY * 8) - 1)-((TileSelectedX * 8) + 8, (TileSelectedY * 8) + 8), RGB(255, 0, 0), B
    Else
      pbxTileset.Line ((SelStartX * 8) - 2, (SelStartY * 8) - 2)-(((SelStartX + SelectWidth) * 8) + 9, ((SelStartY + SelectHeight) * 8) + 9), RGB(255, 0, 0), B
      pbxTileset.Line ((SelStartX * 8) - 1, (SelStartY * 8) - 1)-(((SelStartX + SelectWidth) * 8) + 8, ((SelStartY + SelectHeight) * 8) + 8), RGB(255, 0, 0), B
    End If
  End If
End Sub
